<?xml version="1.0" encoding="utf-8" ?>

<!-- This transformation fixes the audio-cue @cRef attributes which originally contained "CD?:??"
     by extracting the correct values from the audio-cues.xml value -->

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
               xmlns:tei="http://www.tei-c.org/ns/1.0"
               version="1.0">

<xsl:output method="xml" indent="yes" />

<xsl:template match="/">
<xsl:apply-templates />
</xsl:template>

<xsl:template match="tei:ptr[contains(@target,'audio-cues.xml') and contains(@cRef,'?')]">
  <xsl:variable name="cue-id"><xsl:value-of select="substring-after(@target, '#')" /></xsl:variable>
  <xsl:variable name="track" select="document('../der-ring-des-nibelungen/audio-cues.xml')//cue[@id=$cue-id]" />
  <xsl:variable name="cRef"><xsl:value-of select="substring-before(@cRef,'?')" /><xsl:value-of select="substring-after($track/cd,'Das_Rheingold_')" />:<xsl:value-of select="$track/tracksort" /></xsl:variable>
  <xsl:message>[<xsl:value-of select="ancestor::tei:sg/@xml:id" />] <xsl:value-of select="@cRef" /> => <xsl:value-of select="$cRef" /></xsl:message>
  <ptr target="{@target}" cRef="{$cRef}"><xsl:apply-templates /></ptr>
</xsl:template>

<xsl:template match="tei:*" priority="-1">
  <xsl:element name="{local-name()}">
    <xsl:for-each select="@*">
      <xsl:attribute name="{local-name()}"><xsl:value-of select="." /></xsl:attribute>
    </xsl:for-each>
    <xsl:apply-templates />
  </xsl:element>
</xsl:template>

</xsl:transform>
