<?xml version="1.0" encoding="utf-8" ?>

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
               xmlns:mb="http://musicbrainz.org/ns/mmd-2.0#"
               version="1.0">

<xsl:param name="opera" />
<xsl:param name="recording" />

<xsl:output method="xml" />

<xsl:template match="/">
  <xsl:variable name="release-id"><xsl:value-of select="//mb:release[1]/@id" /></xsl:variable>
  <back>
    <timeline
        id="recording-{$recording}"
        unit="s">
      <xsl:apply-templates select="//mb:track" mode="when" />
    </timeline>
    <linkGrp
        type="audio-cues"
        domains="#{$opera} #recording-{$recording} http://musicbrainz.org/release/{$release-id}">
      <xsl:apply-templates select="//mb:track" mode="link" />
    </linkGrp>
  </back>
</xsl:template>

<xsl:template match="mb:track[not(preceding::mb:track)]" mode="when">
  <when id="when-{$recording}/CD{ancestor::mb:medium/mb:position}:{mb:position}" absolute="unknown" />
</xsl:template>

<xsl:template match="mb:track[preceding::mb:track]" mode="when">
  <xsl:variable name="preceding-track" select="preceding::mb:track[1]" />
  <xsl:variable name="preceding-when-id"><xsl:value-of select="$recording" />-CD<xsl:value-of select="$preceding-track/ancestor::mb:medium/mb:position" />-<xsl:value-of select="$preceding-track/mb:position" /></xsl:variable>

  <when id="when-{$recording}/CD{ancestor::mb:medium/mb:position}:{mb:position}" interval="{format-number(number(preceding::mb:track[1]/mb:length) div 1000,0)}" since="#when-{$preceding-when-id}" />
</xsl:template>

<xsl:template match="mb:track" mode="link">
  <xsl:variable name="cue-id"><xsl:value-of select="$recording" />-CD<xsl:value-of select="ancestor::mb:medium/mb:position" />-<xsl:value-of select="mb:position" /></xsl:variable>
  <link target="#cue-{$cue-id} #when-{$cue-id} #{@id}" />
</xsl:template>

</xsl:transform>
